//  File: c06p074.cpp
//  The programmer's guide to C++
//  Copyright (C) 1996,1997 by Adrian P. Robson

#include <iostream.h>
#include <string>
#include <stdlib.h>

const DEFSPACE = 3;

void main( int argc, char* argv[] )
{
   string in;  // input file name
   string out; // output file name
   int spaces;   // number of spaces

   bool error = false;
   if ( argc < 3 )
      error = true;
   else {
      in = argv[1];
      out = argv[2];
      if ( argc == 3 )
         spaces = DEFSPACE;
      else
         if ( argc == 4 )
            spaces = atoi(argv[3]);
         else
            error = true;
   }
   if ( error ) {
      cout << "Format is:" << endl
           << "DETAB <in file> <out file> [<spaces>]"
           << endl;
      exit(99);
   }

//  .. rest of program
   cout << "input file name  = " << in << endl;
   cout << "output file name = " << out << endl;
   cout << "number of spaces = " << spaces << endl;


}