//  File: c10p151.cpp
//  The programmer's guide to C++
//  Copyright (C) 1996,1997 by Adrian P. Robson

#include <iostream.h>

class Base {
public:
   Base( int data ) : basedata(data) {}
   int basef()
      { return basedata; }
private:
   int basedata;
};

class Derived : public Base {
public:
   Derived ( int data )
      : dervdata(data), Base(-data) {}
   int dervf()
      { return dervdata; }
private:
   int dervdata;
};

class Derived2 : public Base {
public:
   Derived2 ( int data )
      : Base(-data) {}
};

void main()
{
   Base b1(1);
   Derived d1(2), d2(3);
   Derived2 d3(4);
   d1 = d2;    // simple copy
   b1 = d2;    // slice
   d2 = b1;    // error: Derived not subtype of Base */
   d3 = d2;    // error: Derived2 not subtype of Dervived */
   cout << b1.basef() << endl; // okay -3 printed
   cout << b1.dervf() << endl; // error: dervf not in Base */
}
