//  File: c04p040.cpp
//  The programmer's guide to C++
//  Copyright (C) 1996,1997 by Adrian P. Robson

#include <iostream.h>
#include <iomanip.h>

const int TOP = 12;

void main()
{
   cout << "\nTables Print Program\n";
   cout <<   "--------------------\n\n";

   bool more = true;
   while ( more ) {
      int table;
      bool goodans;
      do {
         cout << "Give required table (2 to 12): ";
         cin >> table;
         if (table >= 2 && table <= 12)
            goodans = true;
         else {
            cout << "Table must be in range 2 to 12, "
                    "please try again" << endl;
            goodans = false;
         }
      } while ( !goodans );
      cout << endl;
      for ( int i = 1; i <= TOP; i++ ) {
         cout << table << " x " << setw(2) << i
              << " = " << table * i << endl;
      }
      char ans;
      cout << endl << "Another table ( y or n ) ";
      cin >> ans;
      switch ( ans ) {
      case 'Y':
      case 'y':
         more = true;
         break;
      case 'N':
      case 'n':
      default:
         more = false;
      }
   }
}