//  File: c06p075.cpp
//  The programmer's guide to C++
//  Copyright (C) 1996,1997 by Adrian P. Robson

#include <iostream.h>
#include <string>

int print_dogs( const string dogs[], int max )
// Print the names of all dogs
//  return the number of dogs
{
   int dcount = 0;
   for ( int i = 0; i < max; i++ )
      if ( dogs[i].length() != 0 ) {
         cout << dogs[i] << ' ';
         dcount++;
      }
   return dcount;
}

bool add_dog( string dogs[], int max, string adog )
// Add a dog
//  return false if no room, true  if okay
{
   int i = 0;
   while ( dogs[i].length() != 0 && i < max )
     i++;
   if ( i < max ) {
      dogs[i] = adog;
      return true;
   }
   else
      return false;
}

int is_a_dog( const string dogs[], int max, string dog )
// Check if a dog exists
{
   if ( dog == "" )
      return false;
   else {
      int i = 0;
      while ( dog != dogs[i]  && i < max )
        i++;
      return ( i < max );
   }
}

void main()
{
   const int MAX_DOGS = 4;
   string dogs[MAX_DOGS] = {"Cleo","Penny","Brollie"};

   cout << "The dogs are ";
   int dog_count = print_dogs(dogs,MAX_DOGS);
   cout << endl << " and there are "
        << dog_count << " of them." << endl;

   if ( add_dog(dogs,MAX_DOGS,"Moss") ) {
      print_dogs(dogs,MAX_DOGS);
      cout << endl;
   }
   else
      cout << "dont expect this!!!!!" << endl;
   if ( add_dog(dogs,MAX_DOGS,"Fido") ) {
      cout << "dont expect this!!!!!" << endl;
   }
   else
      cout << "no room for dog" << endl;
   if ( is_a_dog(dogs,MAX_DOGS,"Cleo") )
      cout << "Cleo is a dog" << endl;
   else
      cout << "Cleo is not a dog !!!" << endl;
   if ( is_a_dog(dogs,MAX_DOGS,"Ann") )
      cout << "Ann is a dog !!!" << endl;
   else
      cout << "Ann is not a dog" << endl;
}
