//  File: c14p210.cpp
//  The programmer's guide to C++
//  Copyright (C) 1996,1997 by Adrian P. Robson

#include <iostream.h>
#include <limits.h>

void main()
{

   const int NUMVALS = 4;
   int value[NUMVALS];
   int count;

/* this fails if NUMVAL itegers are not entered
   cout << "enter " << NUMVALS << " integers: ";
   for ( count = 0; count < NUMVALS; count++ )
      cin >> value[count]; //*/

   cout << "enter " << NUMVALS << " integers: ";
   bool done;
   do {
      done = true;
      for ( count = 0; count < NUMVALS; count++ ) {
         cin >> value[count];
         if ( cin.fail() ) {
            cin.clear();
            cin.ignore(INT_MAX,'\n');
            cout << "Invalid data," << endl
                 << "please try again: ";
            done = false;
            break;
         }
      }
   } while ( !done );

/* An alternatve method that does not use break
   cout << "enter " << NUMVALS << " integers: ";
   bool done = false;
   while ( !done ) {
      bool fault = false;
      count = 0;
      while ( count < NUMVALS && !fault ) {
         cin >> value[count++];
         if ( cin.fail() ) {
            cin.clear();
            cin.ignore(MAXINT,'\n');
            cout << "Invalid data," << endl
                 << "please try again: ";
            fault = true;
         }
      }
      done = !fault;
   } //*/

   cout << "values entered were" << endl;
   for ( count = 0; count < NUMVALS; count++ )
      cout << value[count] << endl;
}