//  File: c14p212.cpp
//  The programmer's guide to C++
//  Copyright (C) 1996,1997 by Adrian P. Robson

#include <fstream.h>
#include <stdlib.h>

void main()
{
   cout << "file copy beginning" << endl;

   ifstream in;
   in.open("XXX");
   if ( in.fail() ) {
     cout << "Unable to open input file" << endl;
     exit(99);
   }

   ofstream out("test.out");
   if ( !out ) {
     cout << "Unable to open output file" << endl;
     exit(99);
   }

   char c;
   in.get(c);
   while ( !in.eof() ) {
      out.put(c);
      in.get(c);
   }

   cout << "file copy complete" << endl;
}